Index: squid/lib/base64.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/base64.c,v
retrieving revision 1.1.1.1.14.1
retrieving revision 1.1.1.1.14.1.2.1
diff -u -r1.1.1.1.14.1 -r1.1.1.1.14.1.2.1
--- squid/lib/base64.c	5 Feb 2000 20:14:18 -0000	1.1.1.1.14.1
+++ squid/lib/base64.c	7 Jan 2001 09:48:29 -0000	1.1.1.1.14.1.2.1
@@ -1,5 +1,5 @@
 /*
- * $Id: base64.c,v 1.1.1.1.14.1 2000/02/05 20:14:18 hno Exp $
+ * $Id: base64.c,v 1.1.1.1.14.1.2.1 2001/01/07 09:48:29 hno Exp $
  */
 
 #include "config.h"
@@ -114,7 +114,7 @@
 
 /* adopted from http://ftp.sunet.se/pub2/gnu/vm/base64-encode.c with adjustments */
 const char *
-base64_encode_bin(const char * data, int len)
+base64_encode_bin(const char *data, int len)
 {
     static char result[BASE64_RESULT_SZ];
     int bits = 0;
@@ -129,7 +129,7 @@
 	base64_init();
 
     while (len-- && out_cnt < sizeof(result) - 1) {
-	c = (unsigned char)*data++;
+	c = (unsigned char) *data++;
 	bits += c;
 	char_count++;
 	if (char_count == 3) {
Index: squid/lib/ntlmauth.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/ntlmauth.c,v
retrieving revision 1.1.4.4
retrieving revision 1.1.4.5
diff -u -r1.1.4.4 -r1.1.4.5
--- squid/lib/ntlmauth.c	7 Jan 2001 07:27:13 -0000	1.1.4.4
+++ squid/lib/ntlmauth.c	7 Jan 2001 09:48:29 -0000	1.1.4.5
@@ -22,31 +22,33 @@
  */
 
 #include "ntlmauth.h"
-#include "util.h"								/* for base64-related stuff */
+#include "util.h"		/* for base64-related stuff */
 
 /* Dumps NTLM flags to standard error for debugging purposes */
-void ntlm_dump_ntlmssp_flags(u_int32_t flags) {
-	fprintf(stderr,"flags: %s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s\n",
-					(flags&NEGOTIATE_UNICODE?"Unicode ":""),
-					(flags&NEGOTIATE_ASCII?"ASCII ":""),
-					(flags&NEGOTIATE_REQUEST_TARGET?"ReqTgt ":""),
-					(flags&NEGOTIATE_REQUEST_SIGN?"ReqSign ":""),
-					(flags&NEGOTIATE_REQUEST_SEAL?"ReqSeal ":""),
-					(flags&NEGOTIATE_DATAGRAM_STYLE?"Dgram ":""),
-					(flags&NEGOTIATE_USE_LM?"UseLM ":""),
-					(flags&NEGOTIATE_USE_NETWARE?"UseNW ":""),
-					(flags&NEGOTIATE_USE_NTLM?"UseNTLM ":""),
-					(flags&NEGOTIATE_DOMAIN_SUPPLIED?"HaveDomain ":""),
-					(flags&NEGOTIATE_WORKSTATION_SUPPLIED?"HaveWKS ":""),
-					(flags&NEGOTIATE_THIS_IS_LOCAL_CALL?"LocalCall ":""),
-					(flags&NEGOTIATE_ALWAYS_SIGN?"AlwaysSign ":""),
-					(flags&CHALLENGE_TARGET_IS_DOMAIN?"Tgt_is_domain":""),
-					(flags&CHALLENGE_TARGET_IS_SERVER?"Tgt_is_server ":""),
-					(flags&CHALLENGE_TARGET_IS_SHARE?"Tgt_is_share ":""),
-					(flags&REQUEST_INIT_RESPONSE?"Req_init_response ":""),
-					(flags&REQUEST_ACCEPT_RESPONSE?"Req_accept_response ":""),
-					(flags&REQUEST_NON_NT_SESSION_KEY?"Req_nonnt_sesskey ":"")
-					);
+void
+ntlm_dump_ntlmssp_flags(u_int32_t flags)
+{
+    fprintf(stderr, "flags: %s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s\n",
+	(flags & NEGOTIATE_UNICODE ? "Unicode " : ""),
+	(flags & NEGOTIATE_ASCII ? "ASCII " : ""),
+	(flags & NEGOTIATE_REQUEST_TARGET ? "ReqTgt " : ""),
+	(flags & NEGOTIATE_REQUEST_SIGN ? "ReqSign " : ""),
+	(flags & NEGOTIATE_REQUEST_SEAL ? "ReqSeal " : ""),
+	(flags & NEGOTIATE_DATAGRAM_STYLE ? "Dgram " : ""),
+	(flags & NEGOTIATE_USE_LM ? "UseLM " : ""),
+	(flags & NEGOTIATE_USE_NETWARE ? "UseNW " : ""),
+	(flags & NEGOTIATE_USE_NTLM ? "UseNTLM " : ""),
+	(flags & NEGOTIATE_DOMAIN_SUPPLIED ? "HaveDomain " : ""),
+	(flags & NEGOTIATE_WORKSTATION_SUPPLIED ? "HaveWKS " : ""),
+	(flags & NEGOTIATE_THIS_IS_LOCAL_CALL ? "LocalCall " : ""),
+	(flags & NEGOTIATE_ALWAYS_SIGN ? "AlwaysSign " : ""),
+	(flags & CHALLENGE_TARGET_IS_DOMAIN ? "Tgt_is_domain" : ""),
+	(flags & CHALLENGE_TARGET_IS_SERVER ? "Tgt_is_server " : ""),
+	(flags & CHALLENGE_TARGET_IS_SHARE ? "Tgt_is_share " : ""),
+	(flags & REQUEST_INIT_RESPONSE ? "Req_init_response " : ""),
+	(flags & REQUEST_ACCEPT_RESPONSE ? "Req_accept_response " : ""),
+	(flags & REQUEST_NON_NT_SESSION_KEY ? "Req_nonnt_sesskey " : "")
+	);
 }
 
 #define lstring_zero(s) s.str=NULL; s.l=-1;
@@ -57,26 +59,27 @@
  * be used in any way that requires a tailing \0. (he can check whether the
  * value is there though, in that case lstring.length==-1).
  */
-lstring ntlm_fetch_string (char * packet, int32_t length, strhdr *str) {
-	int16_t l;									/* length */
-	int32_t o;									/* offset */
-	lstring rv;
-
-	lstring_zero(rv);
-	
-	l = SSWAP(str->len);
-	o = WSWAP(str->offset);
-	/* debug("fetch_string(plength=%d,l=%d,o=%d)\n",length,l,o); */
-	
-	if (l < 0 || l > MAX_FIELD_LENGTH || o+l > length || o==0) {
-		/* debug("ntlmssp: insane data (l: %d, o: %d)\n", l,o); */
-		return rv;
-	}
-	
-	rv.str=packet+o;
-	rv.l=l;
-		
+lstring
+ntlm_fetch_string(char *packet, int32_t length, strhdr * str)
+{
+    int16_t l;			/* length */
+    int32_t o;			/* offset */
+    lstring rv;
+
+    lstring_zero(rv);
+
+    l = SSWAP(str->len);
+    o = WSWAP(str->offset);
+    /* debug("fetch_string(plength=%d,l=%d,o=%d)\n",length,l,o); */
+
+    if (l < 0 || l > MAX_FIELD_LENGTH || o + l > length || o == 0) {
+	/* debug("ntlmssp: insane data (l: %d, o: %d)\n", l,o); */
 	return rv;
+    }
+    rv.str = packet + o;
+    rv.l = l;
+
+    return rv;
 }
 
 /* Adds something to the payload. The caller must guarrantee that
@@ -85,17 +88,19 @@
  * payload_length and hdr will be modified as a side-effect.
  * base_offset is the payload offset from the packet's beginning, and is
  */
-void ntlm_add_to_payload (char *payload, int *payload_length,
-													strhdr *hdr, char *toadd,
-													int toadd_length, int base_offset) {
-	
-	int l=(*payload_length);
-	memcpy(payload+l,toadd,toadd_length);
-
-	hdr->len=toadd_length;
-	hdr->maxlen=toadd_length;
-	hdr->offset=l+base_offset;	/* 48 is the base offset of the payload */
-	(*payload_length)+=toadd_length;
+void
+ntlm_add_to_payload(char *payload, int *payload_length,
+    strhdr * hdr, char *toadd,
+    int toadd_length, int base_offset)
+{
+
+    int l = (*payload_length);
+    memcpy(payload + l, toadd, toadd_length);
+
+    hdr->len = toadd_length;
+    hdr->maxlen = toadd_length;
+    hdr->offset = l + base_offset;	/* 48 is the base offset of the payload */
+    (*payload_length) += toadd_length;
 }
 
 
@@ -104,28 +109,30 @@
  * note: the storage type for the returned value depends on
  *    base64_encode_bin. Currently this means static storage.
  */
-const char* ntlm_make_challenge(char *domain, char *domain_controller,
-										 char *challenge_nonce, int challenge_nonce_len) {
-	ntlm_challenge ch;
-	int pl=0;
-	const char * encoded;
-	memset(&ch, 0, sizeof(ntlm_challenge)); /* reset */
-	memcpy(ch.signature, "NTLMSSP", 8);	/* set the signature */
-	ch.type = WSWAP(NTLM_CHALLENGE); /* this is a challenge */
-	ntlm_add_to_payload(ch.payload, &pl, &ch.target, domain, strlen(domain),
-								 NTLM_CHALLENGE_HEADER_OFFSET);
-	ch.flags=WSWAP(
-								 REQUEST_NON_NT_SESSION_KEY |
-								 CHALLENGE_TARGET_IS_DOMAIN |
-								 NEGOTIATE_ALWAYS_SIGN |
-								 NEGOTIATE_USE_NTLM |
-								 NEGOTIATE_USE_LM |
-								 NEGOTIATE_ASCII |
-								 0
-								 );
-	ch.context_low=0;							/* check this out */
-	ch.context_high=0; 
-	memcpy(ch.challenge,challenge_nonce,challenge_nonce_len);
- 	encoded=base64_encode_bin((char *)&ch,NTLM_CHALLENGE_HEADER_OFFSET+pl);
-	return encoded;
+const char *
+ntlm_make_challenge(char *domain, char *domain_controller,
+    char *challenge_nonce, int challenge_nonce_len)
+{
+    ntlm_challenge ch;
+    int pl = 0;
+    const char *encoded;
+    memset(&ch, 0, sizeof(ntlm_challenge));	/* reset */
+    memcpy(ch.signature, "NTLMSSP", 8);		/* set the signature */
+    ch.type = WSWAP(NTLM_CHALLENGE);	/* this is a challenge */
+    ntlm_add_to_payload(ch.payload, &pl, &ch.target, domain, strlen(domain),
+	NTLM_CHALLENGE_HEADER_OFFSET);
+    ch.flags = WSWAP(
+	REQUEST_NON_NT_SESSION_KEY |
+	CHALLENGE_TARGET_IS_DOMAIN |
+	NEGOTIATE_ALWAYS_SIGN |
+	NEGOTIATE_USE_NTLM |
+	NEGOTIATE_USE_LM |
+	NEGOTIATE_ASCII |
+	0
+	);
+    ch.context_low = 0;		/* check this out */
+    ch.context_high = 0;
+    memcpy(ch.challenge, challenge_nonce, challenge_nonce_len);
+    encoded = base64_encode_bin((char *) &ch, NTLM_CHALLENGE_HEADER_OFFSET + pl);
+    return encoded;
 }
Index: squid/lib/util.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/util.c,v
retrieving revision 1.1.1.3.10.5.2.1
retrieving revision 1.1.1.3.10.5.2.2
diff -u -r1.1.1.3.10.5.2.1 -r1.1.1.3.10.5.2.2
--- squid/lib/util.c	30 Nov 2000 10:51:58 -0000	1.1.1.3.10.5.2.1
+++ squid/lib/util.c	7 Jan 2001 09:48:29 -0000	1.1.1.3.10.5.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: util.c,v 1.1.1.3.10.5.2.1 2000/11/30 10:51:58 rbcollins Exp $
+ * $Id: util.c,v 1.1.1.3.10.5.2.2 2001/01/07 09:48:29 hno Exp $
  *
  * DEBUG: 
  * AUTHOR: Harvest Derived
@@ -78,7 +78,7 @@
 #if !defined(__CYGWIN__)
 extern int sys_nerr;
 #else
-  #define sys_nerr _sys_nerr
+#define sys_nerr _sys_nerr
 #endif
 
 
@@ -124,9 +124,9 @@
 	return DBG_MAXINDEX;
 
     if (sz <= DBG_SPLIT)
-	return (sz+DBG_GRAIN_SM-1)/DBG_GRAIN_SM;
+	return (sz + DBG_GRAIN_SM - 1) / DBG_GRAIN_SM;
 
-    return (sz+DBG_GRAIN-1)/DBG_GRAIN + DBG_OFFSET;
+    return (sz + DBG_GRAIN - 1) / DBG_GRAIN + DBG_OFFSET;
 }
 
 static void
@@ -475,7 +475,7 @@
 
 #if XMALLOC_DEBUG
     if (s != NULL)
-        check_free(s);
+	check_free(s);
 #endif
     if (s != NULL)
 	free(s);
@@ -632,7 +632,7 @@
     if (errno < 0 || errno >= sys_nerr)
 	snprintf(xstrerror_buf, BUFSIZ, "(%d) Unknown", errno);
     else
-        snprintf(xstrerror_buf, BUFSIZ, "(%d) %s", errno, strerror(errno));
+	snprintf(xstrerror_buf, BUFSIZ, "(%d) %s", errno, strerror(errno));
     return xstrerror_buf;
 }
 
@@ -749,10 +749,10 @@
 }
 
 /* A default failure notifier when the main program hasn't installed any */
-void default_failure_notify(const char *msg)
+void
+default_failure_notify(const char *msg)
 {
     write(2, msg, strlen(msg));
     write(2, "\n", 1);
     abort();
 }
-
Index: squid/lib/uudecode.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/uudecode.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.26.1
diff -u -r1.1.1.1 -r1.1.1.1.26.1
--- squid/lib/uudecode.c	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/lib/uudecode.c	7 Jan 2001 09:48:29 -0000	1.1.1.1.26.1
@@ -1,5 +1,6 @@
+
 /*
- * $Id: uudecode.c,v 1.1.1.1 2000/01/26 03:21:47 hno Exp $
+ * $Id: uudecode.c,v 1.1.1.1.26.1 2001/01/07 09:48:29 hno Exp $
  */
 
 #include "config.h"
Index: squid/ntlm_auth_modules/NTLMSSP/libntlmssp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/ntlm_auth_modules/NTLMSSP/Attic/libntlmssp.c,v
retrieving revision 1.1.2.12.2.7
retrieving revision 1.1.2.12.2.8
diff -u -r1.1.2.12.2.7 -r1.1.2.12.2.8
--- squid/ntlm_auth_modules/NTLMSSP/libntlmssp.c	7 Jan 2001 07:56:15 -0000	1.1.2.12.2.7
+++ squid/ntlm_auth_modules/NTLMSSP/libntlmssp.c	7 Jan 2001 09:48:29 -0000	1.1.2.12.2.8
@@ -15,7 +15,7 @@
 
 
 #include "ntlm.h"
-#include "util.h"								/* from Squid */
+#include "util.h"		/* from Squid */
 #include "valid.h"
 
 #if HAVE_STRING_H
@@ -28,112 +28,119 @@
 #include <unistd.h>
 #endif
 
-#include "smblib-priv.h"				/* for SMB_Handle_Type */
+#include "smblib-priv.h"	/* for SMB_Handle_Type */
 
 /* a few forward-declarations. Hackish, but I don't care right now */
 SMB_Handle_Type SMB_Connect_Server(SMB_Handle_Type Con_Handle,
-		 char *server, char *NTdomain);
+    char *server, char *NTdomain);
 
 /* this one is reallllly haackiish. We really should be using anything from smblib-priv.h
  */
-static char *SMB_Prots[] = {"PC NETWORK PROGRAM 1.0",
-                            "MICROSOFT NETWORKS 1.03",
-                            "MICROSOFT NETWORKS 3.0",
-                            "DOS LANMAN1.0",
-                            "LANMAN1.0",
-                            "DOS LM1.2X002",
-                            "LM1.2X002",
-                            "DOS LANMAN2.1",
-                            "LANMAN2.1",
-                            "Samba",
-                            "NT LM 0.12",
-                            "NT LANMAN 1.0",
-                            NULL};
+static char *SMB_Prots[] =
+{"PC NETWORK PROGRAM 1.0",
+    "MICROSOFT NETWORKS 1.03",
+    "MICROSOFT NETWORKS 3.0",
+    "DOS LANMAN1.0",
+    "LANMAN1.0",
+    "DOS LM1.2X002",
+    "LM1.2X002",
+    "DOS LANMAN2.1",
+    "LANMAN2.1",
+    "Samba",
+    "NT LM 0.12",
+    "NT LANMAN 1.0",
+    NULL};
 
 #if 0
 int SMB_Discon(SMB_Handle_Type Con_Handle, BOOL KeepHandle);
 int SMB_Negotiate(void *Con_Handle, char *Prots[]);
-int SMB_Logon_Server(SMB_Handle_Type Con_Handle, char *UserName, 
-										 char *PassWord, char * Domain, int precrypted);
+int SMB_Logon_Server(SMB_Handle_Type Con_Handle, char *UserName,
+    char *PassWord, char *Domain, int precrypted);
 #endif
 
 #ifdef DEBUG
 #define debug_dump_ntlmssp_flags dump_ntlmssp_flags
-#else	 /* DEBUG */
-#define debug_dump_ntlmssp_flags(X) /* empty */
+#else /* DEBUG */
+#define debug_dump_ntlmssp_flags(X)	/* empty */
 #endif /* DEBUG */
 
 
 static char challenge[NONCE_LEN];
-SMB_Handle_Type handle=NULL;
+SMB_Handle_Type handle = NULL;
 
 /* Disconnects from the DC. A reconnection will be done upon the next request
  */
-void dc_disconnect() {
-	if (handle != NULL)
-		SMB_Discon(handle,0);
-	handle=NULL;
+void 
+dc_disconnect()
+{
+    if (handle != NULL)
+	SMB_Discon(handle, 0);
+    handle = NULL;
 }
 
-int connectedp() {
-	return (handle!=NULL);
+int 
+connectedp()
+{
+    return (handle != NULL);
 }
 
 
 /* Tries to connect to a DC. Returns 0 on failure, 1 on OK */
-int is_dc_ok (char *domain,
-							char *domain_controller) {
-	SMB_Handle_Type h=SMB_Connect_Server(NULL,domain_controller,domain);
-	if (h==NULL)
-		return 0;
-	SMB_Discon(h,0);
-	return 1;
+int 
+is_dc_ok(char *domain,
+    char *domain_controller)
+{
+    SMB_Handle_Type h = SMB_Connect_Server(NULL, domain_controller, domain);
+    if (h == NULL)
+	return 0;
+    SMB_Discon(h, 0);
+    return 1;
 }
 
 
 /* returns 0 on success, > 0 on failure */
-static int init_challenge(char* domain, char* domain_controller) {
-int smberr;
-char errstr[100];
-
-	if (handle != NULL) {
-		return 0;
-	}
-
-	debug("Connecting to server %s domain %s\n",domain_controller,domain);
-	handle=SMB_Connect_Server(NULL,domain_controller,domain);
-        smberr=SMB_Get_Last_Error();
-        SMB_Get_Error_Msg(smberr,errstr,100);
-        
-	
-	if (handle==NULL) {	/* couldn't connect */
-		debug("Couldn't connect to SMB Server. Error:%s\n",errstr);
-		return 1;
-	}
-	
-	if (SMB_Negotiate(handle, SMB_Prots) < 0) { /* An error */
-		debug("Error negotiating protocol with SMB Server\n");
-		SMB_Discon(handle,0);
-		handle=NULL;
-		return 2;
-	}
-	
-	if (handle -> Security == 0) {	/* share-level security, unuseable */
-		debug("SMB Server uses share-level security .. we need user sercurity.\n");
-		SMB_Discon(handle,0);
-		handle=NULL;
-		return 3;
-	}
-	
-	memcpy(challenge, handle->Encrypt_Key, NONCE_LEN);
+static int 
+init_challenge(char *domain, char *domain_controller)
+{
+    int smberr;
+    char errstr[100];
+
+    if (handle != NULL) {
 	return 0;
-}
+    }
+    debug("Connecting to server %s domain %s\n", domain_controller, domain);
+    handle = SMB_Connect_Server(NULL, domain_controller, domain);
+    smberr = SMB_Get_Last_Error();
+    SMB_Get_Error_Msg(smberr, errstr, 100);
 
-const char *make_challenge (char *domain, char *domain_controller) {
-	if (init_challenge(domain,domain_controller) > 0)
-		return NULL;
-	return ntlm_make_challenge(domain, domain_controller,challenge,
-		NONCE_LEN);
+
+    if (handle == NULL) {	/* couldn't connect */
+	debug("Couldn't connect to SMB Server. Error:%s\n", errstr);
+	return 1;
+    }
+    if (SMB_Negotiate(handle, SMB_Prots) < 0) {		/* An error */
+	debug("Error negotiating protocol with SMB Server\n");
+	SMB_Discon(handle, 0);
+	handle = NULL;
+	return 2;
+    }
+    if (handle->Security == 0) {	/* share-level security, unuseable */
+	debug("SMB Server uses share-level security .. we need user sercurity.\n");
+	SMB_Discon(handle, 0);
+	handle = NULL;
+	return 3;
+    }
+    memcpy(challenge, handle->Encrypt_Key, NONCE_LEN);
+    return 0;
+}
+
+const char *
+make_challenge(char *domain, char *domain_controller)
+{
+    if (init_challenge(domain, domain_controller) > 0)
+	return NULL;
+    return ntlm_make_challenge(domain, domain_controller, challenge,
+	NONCE_LEN);
 }
 
 #define min(A,B) (A<B?A:B)
@@ -145,70 +152,70 @@
  */
 int ntlm_errno;
 static char credentials[1024];	/* we can afford to waste */
-char * ntlm_check_auth(ntlm_authenticate * auth, int auth_length) {
-	int rv, retries=0;
-	char pass[25];
-	char *domain=credentials;
-	char *user;
-	lstring tmp;
-	
-	if (handle==NULL) { /*if null we aren't connected, but it shouldn't happen*/
-		debug("Weird, we've been disconnected\n");
-		ntlm_errno=NTLM_NOT_CONNECTED;
-		return NULL;
-	}
-
-	/* Authenticating against the NT response doesn't seem to work... */
-	tmp=ntlm_fetch_string((char *)auth,auth_length,&auth->lmresponse);
-	if (tmp.str==NULL) {
-		fprintf(stderr,"No auth at all. Returning no-auth\n");
-		ntlm_errno=NTLM_LOGON_ERROR;
-		return NULL;
-	}
-	memcpy(pass,tmp.str,tmp.l);
-	pass[25]='\0';
-
-/* 	debug("fetching domain\n"); */
-	tmp=ntlm_fetch_string((char *)auth,auth_length,&auth->domain);
-	if (tmp.str==NULL) {
-		debug("No domain supplied. Returning no-auth\n");
-		ntlm_errno=NTLM_LOGON_ERROR;
-		return NULL;
-	}
-	memcpy(domain,tmp.str,tmp.l);
-	user=domain+tmp.l;
-	*user++='\0';
-
-/* 	debug("fetching user name\n"); */
-	tmp=ntlm_fetch_string((char *)auth,auth_length,&auth->user);
-	if (tmp.str==NULL) {
-		debug("No username supplied. Returning no-auth\n");
-		ntlm_errno=NTLM_LOGON_ERROR;
-		return NULL;
-	}
-	memcpy(user,tmp.str,tmp.l);
-	*(user+tmp.l)='\0';
-
-	debug("checking domain: '%s', user: '%s', pass='%s'\n",domain,user,pass);
-
-	rv=SMB_Logon_Server(handle,user,pass,domain,1);
-
-	while ( (rv == NTLM_BAD_PROTOCOL || rv==NTLM_SERVER_ERROR)
-					&& retries < BAD_DC_RETRIES_NUMBER) {
-		retries++;
-		usleep ((unsigned long)100000);
-		rv=SMB_Logon_Server(handle,user,pass,domain,1);
-	}
-
-	debug("\tresult is %d\n",rv);
-	
-	if (rv!=NTV_NO_ERROR){   /* failed */
-		ntlm_errno=rv;
-		return NULL;
-	}
-
-	*(user-1)='\\';
+char *
+ntlm_check_auth(ntlm_authenticate * auth, int auth_length)
+{
+    int rv, retries = 0;
+    char pass[25];
+    char *domain = credentials;
+    char *user;
+    lstring tmp;
+
+    if (handle == NULL) {	/*if null we aren't connected, but it shouldn't happen */
+	debug("Weird, we've been disconnected\n");
+	ntlm_errno = NTLM_NOT_CONNECTED;
+	return NULL;
+    }
+    /* Authenticating against the NT response doesn't seem to work... */
+    tmp = ntlm_fetch_string((char *) auth, auth_length, &auth->lmresponse);
+    if (tmp.str == NULL) {
+	fprintf(stderr, "No auth at all. Returning no-auth\n");
+	ntlm_errno = NTLM_LOGON_ERROR;
+	return NULL;
+    }
+    memcpy(pass, tmp.str, tmp.l);
+    pass[25] = '\0';
+
+/*      debug("fetching domain\n"); */
+    tmp = ntlm_fetch_string((char *) auth, auth_length, &auth->domain);
+    if (tmp.str == NULL) {
+	debug("No domain supplied. Returning no-auth\n");
+	ntlm_errno = NTLM_LOGON_ERROR;
+	return NULL;
+    }
+    memcpy(domain, tmp.str, tmp.l);
+    user = domain + tmp.l;
+    *user++ = '\0';
+
+/*      debug("fetching user name\n"); */
+    tmp = ntlm_fetch_string((char *) auth, auth_length, &auth->user);
+    if (tmp.str == NULL) {
+	debug("No username supplied. Returning no-auth\n");
+	ntlm_errno = NTLM_LOGON_ERROR;
+	return NULL;
+    }
+    memcpy(user, tmp.str, tmp.l);
+    *(user + tmp.l) = '\0';
+
+    debug("checking domain: '%s', user: '%s', pass='%s'\n", domain, user, pass);
+
+    rv = SMB_Logon_Server(handle, user, pass, domain, 1);
+
+    while ((rv == NTLM_BAD_PROTOCOL || rv == NTLM_SERVER_ERROR)
+	&& retries < BAD_DC_RETRIES_NUMBER) {
+	retries++;
+	usleep((unsigned long) 100000);
+	rv = SMB_Logon_Server(handle, user, pass, domain, 1);
+    }
+
+    debug("\tresult is %d\n", rv);
+
+    if (rv != NTV_NO_ERROR) {	/* failed */
+	ntlm_errno = rv;
+	return NULL;
+    }
+    *(user - 1) = '\\';
 
-	debug("credentials: %s\n",credentials);
-	return credentials;
+    debug("credentials: %s\n", credentials);
+    return credentials;
 }
